@warnings 0
vm;
c0..5; c2a;

c2a_active: val {	return(val); }
c4_refresh: val
{
	if(vm)
		setvalue(c3,vm[val]);
	
}

c0_active: val
{
	if(val == 1)
		return(true);
	if(val == 2)
		return(false);
}

c0_refresh: val
{
	if(val == 2)
		setvalue(c2a,true);
}
check2
{
	selmode(USER);
	pc = pointcount();
	editbegin();
	vm = VMap(VMWEIGHT);
	editend();
	i = 0;
	while(vm && vm.type == VMWEIGHT)
	{
		vma[++i] = vm;
		vm = vm.next();
	}

	m = vma[1];
	f = File("c:/temptemp.txt","w+");
	
	for(i=1;i<=pc;i++)
	{
		selpoint(CLEAR);
		selpoint(SET,POINTNDX,i);
		editbegin();
		
		pnt = points[1];
		a = m.getValue(pnt,1);
		editend();
		str = string(a) + " " + i;
		f.writeln(str);
	}
	reqabort();
}
main
{
	editbegin();
	v = VMap(VMWEIGHT);
	i = 0;
	while(v && v.type == VMWEIGHT)
	{
		vm[++i] = v.name;
		v = v.next();
	}
	editend();
	
	op = integer(recall("op",1));
	np = integer(recall("np",1));
	type = integer(recall("type",1));
	twp = integer(recall("twp",1));
	br = number(recall("br",25.0));
	ao = integer(recall("ao",1));
	if(vm)
		wmStr = vm[1];
	else
		wmStr = "";
	
	reqbegin("Create Time-Weighted Particles");
	c0 = ctlchoice("Operation",op,@"New Particles","Apply Weights"@);
	
	c1 = ctlinteger("Number of Particles",np);
	c2 = ctlchoice("Type",type,@"Points","Polygons"@);

	c2a = ctlcheckbox("Time-Weight Particles",twp);

	c3 = ctlstring("Weight Map",wmStr);
	if(vm)
		c4 = ctlpopup("",1,vm);
	else
		c4 = ctlpopup("",1,@"No Weight Maps in System"@);

	c5 = ctlnumber("Birth Rate [per frame]",br);
	c6 = ctlchoice("Assignment Order",ao,@"Min - Max","Min - Max - Min"@);
	c7 = ctlbutton("check2",100,"check2");

	ctlposition(c4,212,101,24);

	ctlactive(c0,"c0_active",c1,c2);
	ctlrefresh(c0,"c0_refresh");

	ctlactive(c2a,"c2a_active",c3,c4,c5);
	ctlrefresh(c4,"c4_refresh");
	
	
	return if(!reqpost());
	
	op = getvalue(c0);
	np = getvalue(c1);
	type = getvalue(c2);
	twp = getvalue(c2a);
	wmStr = getvalue(c3);
	br = getvalue(c5);
	ao = getvalue(c6);

	store("op",op);
	store("np",np);
	store("type",type);
	store("twp",twp);
	store("br",br);
	store("ao",ao);
	
	selmode(USER);
	
	pc = pointcount();
	selpoint(CLEAR);

	for(i=1;i<=pc;i++)
		selpoint(SET,POINTNDX,i);


	pc = editbegin();
	if(op == 2 && pc == 0)
		error("No points.");

	if(twp == true)	
		wm = VMap(VMWEIGHT,wmStr,1);
		
	if(op == 1)
	{
		for(i=1;i<=np;i++)
			p = addpoint(<0,0,0>);
		if(twp == true)
		{
			editend();
			if(type == 2)
				cmdseq("Points2Polys");

			pc = editbegin();
			applyWeights(pc,wm,br,ao);
		}


	}
	if(op == 2 && twp == true)
		applyWeights(pc,wm,br,ao);


}
applyWeights: pc, wm, br, ao
{

	prt = pc / br; // how many 'throws` br is birthrate
//	w = 1 / prt; // w is how much weight difference between throws
	prtcnt = 1; // throw counter

	for(i=1;i<=pc;i++)
	{
		if(i > (prtcnt * br))
			prtcnt++;

		if(ao == 1)
		{
//			val = (prtcnt * w); // 0 to 100
			val = ((prt - prtcnt + 1) * (prtcnt + 1)) / 100;
//			val = (prtcnt * 2) / 100; // 0 to 100
		}
		if(ao == 2)
		{
//			val = ((prt - prtcnt + 1) * w); // 100 to 0
			val = ((prt - prtcnt + 1) * (prt - prtcnt + 1)) / 100;
		}

		wm.setValue(points[i],val);
	}
}
