@version 2.6
@warnings
@script displace
@define SUPRESS 1
@define NONSUP 2
pemit; partObj;
pc; // point counter
c1..2;
freshload = false; loadpemit;
deathloc;
create: moa
{
	setdesc("PFX to Displacement");
	if(freshload == false)
	{
		pemit = moa;
		acquireParticleObject(SUPRESS);
		deathloc = <0,10,0>;
	}
}

flags { return(PREBONE); } 

options
{
	reqbegin("ParticleFX to Displacement");
	c1 = ctlmeshitems("Reference Emitter",pemit);
	c2 = ctlvector("Particle Death Location [m]",deathloc);
	ctlrefresh(c1,"c1_refresh");
	ctlrefresh(c2,"c2_refresh");
	
	reqopen();
}
c2_refresh: val
{
	deathloc = getvalue(c2);
}
c1_refresh: val
{
	pemit = getvalue(c1);
	acquireParticleObject(NONSUP);
}
newtime: id, frame, time
{
	pc = 0;
}
process: da
{
	if(freshload == true)
	{
		m = Mesh(loadpemit);
		if(!m)
			warn("Cannot find saved reference emitter.");
		else
			pemit = m;
		acquireParticleObject(SUPRESS);
		freshload = false;
	}
		
	++pc;
	if(!partObj)
		return;
	
	if(pc <= partObj.count)
		newpos = partObj.getParticle(pc,PART_POSITION);
	else
		newpos = deathloc;

	original = <da.oPos[1],da.oPos[2],da.oPos[3]>;

	da.source[1] = newpos.x + original.x;
	da.source[2] = newpos.y + original.y;
	da.source[3] = newpos.z + original.z;

}
acquireParticleObject: mode
{
	if(pemit != nil)
	{
		Particle(pemit);
		if(sizeof(this) == 0)
		{
			if(mode == NONSUP)
				warn("No Particle system on selected item!"); // this is a workaround because Particle constructor does not return nil on absence of PFX
		}
		else
			(partObj) = Particle(pemit);
	}

}

save: what, io
{
	if(what == SCENEMODE)
	{
		io.writeln(pemit.name);
		io.writeln(string(deathloc));
	}
}
load: what, io
{
	freshload = true;
	if(what == SCENEMODE)
	{
		loadpemit = io.read();
		deathloc = vector(io.read());
	}
	
}
